; Input box tool , Version 1.0

include     InputBox.inc

BUFSIZE     equ 512

.data

StrLength   dd 0
welcome     db 'Input box tool',13,10
            db 'Version 1.0 by Vortex',13,10,13,10
            db 'Usage : inputbox.exe  text , title , x-coordinate , y-coordinate',0

subKey      db 'Environment',0
valName     db 'InputBoxString',0

.data?

buffer      db BUFSIZE dup(?)
key1        dd ?        
result      dd ?

.code

main PROC C uses esi edi argc:DWORD,argv:DWORD

    cmp     argc,1+4
    je      @f
;   invoke  StdOut,ADDR welcome
    ret
@@:
    mov     esi,argv

    invoke  atodw,DWORD PTR [esi+12]
    mov     edi,eax
    
    invoke  atodw,DWORD PTR [esi+16]

    mov     edx,OFFSET buffer
    mov     BYTE PTR [edx],0

    invoke  InputBox,DWORD PTR [esi+4],\    ; address of the text
                     DWORD PTR [esi+8],\    ; address of the title of the input box
                     edx,\                  ; address of the buffer receiving the input text
                     edi,\                  ; x-coordinate of the input box
                     eax,\                  ; y-coordinate of the input box
                     ADDR StrLength         ; pointer to the number of characters received to the input box

    mov     result,eax

    invoke  RegOpenKeyEx,HKEY_CURRENT_USER,ADDR subKey,0,\
            KEY_ALL_ACCESS,ADDR key1

    invoke  RegSetValueEx,key1,ADDR valName,0,\
            REG_SZ,ADDR buffer,StrLength

    invoke  RegCloseKey,key1

    mov     eax,result
    ret
    
main ENDP

END

