include     InputBox.inc

IDC_EDIT    equ 4001
IDB_OK      equ 4002
IDB_EXIT    equ 4003
IDC_STATIC  equ 4004

.data?

IBparams    dd ?
hEditBoxIB  dd ?
StrLenAddr  dd ?

.code

IBDlgProc PROC USES esi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	
    .IF uMsg==WM_INITDIALOG

        mov     esi,lParam
        mov     edx,DWORD PTR [esi]
        mov     StrLenAddr,edx
        mov     IBparams,esi
        invoke  GetDlgItem,hWnd,IDC_STATIC			
        invoke  SendMessage,eax,WM_SETTEXT,0,DWORD PTR [esi-20]
        invoke  SendMessage,hWnd,WM_SETTEXT,0,DWORD PTR [esi-16]
        invoke  GetDlgItem,hWnd,IDC_EDIT
        mov     hEditBoxIB,eax

    .ELSEIF uMsg==WM_CLOSE

        invoke  EndDialog,hWnd,0

    .ELSEIF uMsg==WM_COMMAND
		
        mov  eax,wParam
        mov  edx,eax
        shr  edx,16

        .IF dx==BN_CLICKED
                                
             .IF ax==IDB_EXIT

                  invoke  EndDialog,hWnd,0

             .ELSEIF ax==IDB_OK || ax==IDOK                        ; check also if RETURN \ ENTER is pressed

                  mov     esi,hEditBoxIB
                  invoke  SendMessage,esi,WM_GETTEXTLENGTH,0,0
                  test    eax,eax                                  ; check the length of the input text
                  jz      @f                                       ; if no text is entered then quit application
                  inc     eax
                  mov     edx,IBparams                 
                  invoke  SendMessage,esi,WM_GETTEXT,eax,\
                          DWORD PTR [edx-12]                       ; DWORD PTR [edx] -> pointer to the buffer receiving
                                                                   ; keyboard input
@@:
                  mov      edx,StrLenAddr
                  mov      DWORD PTR [edx],eax
                  invoke   EndDialog,hWnd,1

             .ENDIF

        .ENDIF
       
     .ELSE

        xor	eax,eax
        ret

     .ENDIF

     mov  eax,TRUE
     ret

IBDlgProc ENDP





END

