include	  InputBox.inc

IBDlgProc     PROTO hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

DLGBOX_COORD  equ 18

.data

; Binary resource template extracted with res2obj

Rsrc          db 1,0,255,255,0,0,0,0,0,0,0,0,204,0,200,144
              db 4,0,44,1,250,0,238,0,82,0,0,0,0,0,0,0
              db 8,0,0,0,0,1,77,0,83,0,32,0,83,0,104,0
              db 101,0,108,0,108,0,32,0,68,0,108,0,103,0,0,0
              db 0,0,0,0,0,0,0,0,128,0,129,80,7,0,60,0
              db 224,0,16,0,161,15,0,0,255,255,129,0,0,0,0,0
              db 0,0,0,0,0,0,0,0,0,0,1,80,176,0,8,0
              db 52,0,16,0,162,15,0,0,255,255,128,0,79,0,75,0
              db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,80
              db 176,0,28,0,52,0,16,0,163,15,0,0,255,255,128,0
              db 67,0,97,0,110,0,99,0,101,0,108,0,0,0,0,0
              db 0,0,0,0,0,0,0,0,0,0,2,80,8,0,8,0
              db 156,0,40,0,164,15,0,0,255,255,130,0,0,0,0,0

.code

InputBox PROC pText:DWORD,\     ; address of text to displayed in the static control
              pCaption:DWORD,\  ; address of title of input box
              pBuffer:DWORD,\   ; address of buffer receiving the input text
              xpos:DWORD,\      ; x-coordinate of input box
              ypos:DWORD,\      ; y-coordinate of input box
              pStringLen:DWORD  ; pointer to number of characters received to the input box

; Return values :

;             If the user clicks the OK button, the return value is 1
;             If the user clicks the cancel button, the return value is 0
;             The number of characters received to the input box : pStringLen

        mov     eax,ypos
        shl     eax,16
        or      eax,xpos
        mov     DWORD PTR [Rsrc+DLGBOX_COORD],eax
                                ; set the coordinates of the input box

        invoke  GetModuleHandle,0
        lea     edx,[esp+7*4]   ; get the stack address pointing the parameters of InputBox
        
        invoke  DialogBoxIndirectParam,eax,ADDR Rsrc,0,ADDR IBDlgProc,edx
        ret

InputBox ENDP

END
